unit main;
**********************************************************************
* Feel free to use or give away this software as you see fit.        *
* Please leave the credits in place if you alter the source.         *
*                                                                    *
* This software is delivered to you "as is",                         *
* no guarantees of any kind.                                         *
*                                                                    *
* If you find any bugs, please let me know, I will try to fix them.  *
* If you modify the source code, please send me a copy               *
*                                                                    *
* If you like this component,  and also if you dislike it ;), please *
* send me an E-mail with your comment                                *
* Marco Caselli                                                      *
* Web site : http://members.tripod.com/dartclub                      *
* E-mail   : mcaselli@iname.com                                      *
**********************************************************************
*** Sorry for my bad english ...............
interface

uses
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   Menus, ExtCtrls, StdCtrls, ComCtrls, math, DIBUltra, DIBType, RegValues;

type
   Tpiece = record
      x, y: integer;
      col: array[1..3] of byte;
   end;

   Tgametable = array [1..6, 1..18] of byte;


   TMainForm = class(TForm)
      MainMenu1: TMainMenu;
      Game1: TMenuItem;
      Timer1: TTimer;
      NewGame1: TMenuItem;
      RV: TRegValues;
    Options1: TMenuItem;
    sb: TStatusBar;
    N1: TMenuItem;
      procedure boxPaint(Sender: TObject);
      procedure Timer1Timer(Sender: TObject);
      procedure NewGame1Click(Sender: TObject);
      procedure FormDestroy(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure N1Click(Sender: TObject);
   private
      DIB          : TDibUltra;
      oldx, oldy   : integer;
      punti        : integer;
      GIRO         : byte;
      table        : Tgametable;
      newtable     : Tgametable;
      baseline     : array[1..6] of byte;
      activePiece  : boolean;
      running      : boolean;
      Calculating  : boolean;
      piece        : TPiece;

      procedure     GetCellSize;
      function      Make_Piece: TPiece;
      procedure     Rotate_Piece;
      procedure     Calculate;
      procedure     PieceToTable;
      procedure     LoopColor;
      procedure     ClearTable(var Xtable: TGameTable);
      function      Pack(Xtable: TgameTable): TGameTable;
      function      GetColor(color: byte): TColor;
      procedure     Initialize;
   protected
      procedure     KeyDown(var Key: Word; Shift: TShiftState); OVERRIDE;
      { Private declarations }
   public
      cellw        : integer;
      cellh        : integer;
      { Public declarations }
   end;

var
   MainForm: TMainForm;

implementation

uses Unit1, param;

{$R *.DFM}

procedure  TMainForm.GetCellSize;
begin
   clientwidth := cellw * 6 + 1;
   clientHeight := cellh * 18 + 1;

end;

procedure  TMainForm.ClearTable(var Xtable: TGameTable);
var i, j: integer;
begin
   for i := 1 to 6 do
      for j := 1 to 18 do
         Xtable[i, j] := 0;

end;

function TMainForm.Make_Piece: TPiece;
var i: integer;
begin
   for i := 1 to 3 do
      result.col[i] := round(power(2, (random(6) + 1)));
   result.x := random(6) + 1;
   result.y := 18;
end;

procedure TMainForm.Rotate_piece;
var tmp: byte;
begin
   with piece do
   begin
      tmp := col[1];
      col[1] := col[2];
      col[2] := col[3];
      col[3] := tmp;
   end;
   PAINT;
end;

function TMainForm.GetColor(Color: byte): TColor;
begin
   result := clwhite;
   case color of
      2: result := clred;
      4: result := clgreen;
      8: result := clyellow;
      16: result := clblack;
      32: result := clblue;
      64: result := clsilver;
      128: result := cllime;
   end;

end;

function TMainForm.Pack(xtable: TGameTable): TGameTable;
var
   i, j, k     : integer;

begin

   ClearTable(result);

   for i := 1 to 6 do
   begin
      k := 0;
      for j := 1 to 18 do
         if xtable[i, j] <> 128 then
         begin
            inc(k);
            result[i, k] := xtable[i, j];
         end
         else
            dec(baseline[i]);
      end;
   end;

procedure TMainForm.Calculate;
var
   i, j         : integer;
   done        : boolean;
begin
   calculating := true;
   repeat
      newtable := table;
      done := true;
      for i := 1 to 6 do
         for j := 1 to 18 do
            if table[i, j] <> 0 then
            begin
               if i < 5 then
                  if table[i, j] = (table[i + 1, j] AND table[i + 2, j]) then
                  begin
                     newtable[i, j] := 128;
                     newtable[i + 1, j] := 128;
                     newtable[i + 2, j] := 128;
                     done := false;
                     inc(punti);
                  end;
               if j > 2 then
                  if table[i, j] = (table[i, j - 1] AND table[i, j - 2]) then
                     begin
                        newtable[i, j] := 128;
                        newtable[i, j - 1] := 128;
                        newtable[i, j - 2] := 128;
                        done := false;
                        inc(punti);
                     end;
               if (j < 17) and (i < 5) then
                  if table[i, j] = (table[i + 1, j + 1] AND table[i + 2, j + 2]) then
                     begin
                        newtable[i, j] := 128;
                        newtable[i + 1, j + 1] := 128;
                        newtable[i + 2, j + 2] := 128;
                        done := false;
                        inc(punti);
                     end;
               if (j > 2) and (i < 5) then
                  if table[i, j] = (table[i + 1, j - 1] AND table[i + 2, j - 2]) then
                     begin
                        newtable[i, j] := 128;
                        newtable[i + 1, j - 1] := 128;
                        newtable[i + 2, j - 2] := 128;
                        done := false;
                        inc(punti);
                     end;

              end;

              if not done then
                 begin
                    loopcolor;
                    table := pack(NewTable);
                 end;

   until done;
   sb.simpletext := 'Punti ' + inttostr(punti);
//   CAPTION:='P: ' + inttostr(punti);
   dib.BrushColor := clwhite;
   dib.clearAll;
   paint;
   calculating := false;
end;


procedure TMainForm.PieceToTable;
var i: integer;
begin
   inc(baseline[piece.x], 3);
   if baseline[piece.x] > 18 then
   begin
      running := false;
      messagedlg('Game Over', mtcustom, [mbOk], 0);
   end;

   for i := 1 to 3 do
   begin
      table[piece.x, baseline[piece.x] + i - 3] := piece.col[i];
   end;
   oldx := 0;
   oldy := 0;
   piece := Make_piece;

end;

procedure TMainForm.Loopcolor;
var
   i, j: integer;
   tmpcol: tcolor;
begin
   giro := 1;
   dib.BrushColor := clwhite;
   dib.ClearAll;
   paint;
   repeat
      with DIB do
         for i := 1 to 6 do
            for j := 1 to 18 do
            begin
               if newtable[i, j] = 128 then
               begin
                  case giro of
                     1, 3: tmpcol := clwhite;
                     2: tmpcol := getcolor(table[i, j]);
                  end;
                  brushcolor := tmpcol;
                  fillrect(rect((i - 1) * cellw, (18 - j ) * cellh, i * cellw, (18 - j+1) * cellh));
               end;
            end;
            inc(giro);
            DIB.DrawOn(clientrect, canvas, 0, 0);
            sleepex(190, false);
         until giro = 3;

      END;
procedure TMainForm.boxPaint(Sender: TObject);
var
   i, j: integer;
   tmpcol: tcolor;
begin
   with DIB do
   begin
      for i := 1 to 6 do
         for j := 1 to 18 do
         begin
            if table[i, j] <> 0 then
            begin
               tmpcol := getcolor(table[i, j]);
               brushcolor := tmpcol;
               fillrect(rect((i - 1) * cellw, (18 - j ) * cellh, i * cellw, (18 - j+1) * cellh));
            end;
         end;

         if activepiece then
         begin
            brushcolor := clwhite;
            FillRect(rect((oldx - 1) * cellw, (18 - oldy - 4) * cellh, oldx * cellw, (18 - oldy) * cellh));
            for i := 1 to 3 do
               with piece do
               begin
                  tmpcol := getcolor(col[i]);
                  brushcolor := tmpcol;
                  fillrect(rect((x - 1) * cellw, (18 - y - i - 1) * cellw, x * cellw, (18 - y - i) * cellh));
               end;
               oldx := piece.x;
               oldy := piece.y;
            end;
         end;
         DIB.DrawOn(clientrect, canvas, 0, 0);
      end;

procedure TMainForm.Initialize;
var
   i: integer;
begin
   cellh:=Cellw;
   getcellsize;
   randomize;
   activepiece := true;
   oldx := 0;
   oldy := 0;
   Piece := Make_piece;
   dib.Free;
   DIB := Tdibultra.Create(clientwidth, clientheight, Dupf16, nil);
   Dib.gdistyle := true;
   dib.brushcolor := clwhite;
   dib.clearall;
   punti:=0;
   sb.simpletext := 'Punti ' + inttostr(punti);
   for i := 1 to 6 do
      baseline[i] := 0;
   ClearTable(Table);

end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
   if running and not calculating then
   begin
      dec(piece.y);
      paint;
      if piece.y < baseline[piece.x] then
      begin
         PieceToTable;
         calculate;
      end;
   end;
end;

procedure TMainForm.NewGame1Click(Sender: TObject);
begin
   running := true;
   initialize;
end;

procedure TMainForm.KeyDown(var Key: Word;
Shift: TShiftState);
begin
   if key = vk_escape then
      application.minimize;

   if not running then
   begin
      inherited;
      exit;
   end;

   if key = vk_space then
   begin
      piece.y := Baseline[piece.x];
      PAINT;
      PieceToTable;
      calculate;

   end;

   if  key in [vk_down, vk_up] then
      rotate_piece;

   if  key = vk_left then
      if piece.x > 1  then
      if piece.y > baseline[piece.x - 1] then
      dec(piece.x);

   if key = vk_f3 then
      if timer1.enabled then
      begin
         sb.simpletext := 'P A U S E D';
         timer1.enabled := false;
         end else
         begin
//           CAPTION:='Punti ' + inttostr(punti);
            sb.simpletext := 'Punti ' + inttostr(punti);
            timer1.enabled := true;
         end;

         if  key = vk_right then
            if piece.x < 6 then
            if piece.y >= baseline[piece.x + 1] then
            inc(piece.x);

         PAINT;
         inherited;

      end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
   Dib.free;
   rv.setv('Speed',timer1.Interval);
   rv.setv('Blocksize',cellw);
   RV.SaveValues;
end;

procedure TMainForm.Options1Click(Sender: TObject);
begin
     pagesdlg.PageControl1.ActivePage:=pagesdlg.Parameters;
     pagesdlg.showmodal;
     if pagesdlg.modalresult <> mrCancel then
        initialize;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
RV.loadValues;
Timer1.Interval:=RV.Get('Speed');
Cellw:=rv.Get('Blocksize');

initialize;

end;

procedure TMainForm.N1Click(Sender: TObject);
begin
     pagesdlg.PageControl1.ActivePage:=pagesdlg.About;
     pagesdlg.showmodal;
end;

end.
